#
# Conditional build:
%bcond_without	libunwind	# strack tracing using libunwind
#
%ifnarch %{ix86} %{x8664} arm hppa ia64 mips ppc ppc64 sh
%undefine	with_libunwind
%endif
Summary:	prints system call strace of a running process
Summary(de.UTF-8):	druckt ein Protokoll der Systemaufrufe eines laufenden Prozesses
Summary(es.UTF-8):	Enseña las llamadas de sistema de un proceso en ejecución
Summary(fr.UTF-8):	affiche l'appel système strace d'un processus en exécution
Summary(pl.UTF-8):	strace wyświetla funkcje systemowe wywoływane przez uruchomiony proces
Summary(pt_BR.UTF-8):	Mostra as chamadas de sistema de um processo rodando
Summary(ru.UTF-8):	Отслеживает и показывает системные вызовы, связанные с запущенным процессом
Summary(tr.UTF-8):	Çalışan bir sürecin yaptığı sistem çağrılarını listeler
Summary(uk.UTF-8):	Відслідковує та показує системні виклики, пов'язані із запущеним процесом
Name:		strace
Version:	4.20
Release:	1
License:	BSD-like
Group:		Development/Debuggers
Source0:	http://downloads.sourceforge.net/strace/%{name}-%{version}.tar.xz
# Source0-md5:	f2271ab0fac49ebee9cbd7f3469227cb
Source1:	%{name}.1.pl
URL:		http://sourceforge.net/projects/strace/
# acl and libaio for headers only
BuildRequires:	acl-devel
BuildRequires:	libaio-devel
%{?with_libunwind:BuildRequires:	libunwind-devel}
BuildRequires:	tar >= 1:1.22
BuildRequires:	xz
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Strace prints a record of each system call another program makes,
including all of the arguments passed to it and the system call's
return value.

%description -l de.UTF-8
Strace druckt ein Protokoll aller von einem anderen Programm
ausgegebenen Systemaufrufe, einschließlich aller weitergeleiteten
Argumente und dem Ausgabewert des Systemaufrufs.

%description -l es.UTF-8
Strace imprime una "grabación" de cada llamada de sistema que el
programa hace, incluyendo todos los argumentos pasados para él, si la
vuelta de cada llamada de sistema es verdadera, o si hay creado error.

%description -l fr.UTF-8
strace affiche l'enregistrement de chaque appel système que fait un
programme ainsi que tous les arguments qui lui ont été passés et la
valeur de retour de l'appel.

%description -l pl.UTF-8
Strace wyświetla informacje o każdym wywołaniu funkcji systemowych
przez uruchamiany program, w tym również wszystkie argumenty wywołania
i zwróconą wartość.

%description -l pt_BR.UTF-8
Strace imprime uma "gravação" de cada chamada de sistema que o
programa faz, incluindo todos os argumentos passados para ele e se o
retorno de cada chamada de sistema é verdadeiro ou gerou erro.

%description -l ru.UTF-8
Программа strace перехватывает и регистрирует системные вызовы,
произведенные и полученные исполняющимся процессом. Strace может
вывести список всех системных вызовов, их аргументов и возвращаемые
ими значения. Strace полезна для диагностики проблем и отладки.

%description -l tr.UTF-8
strace bir programın çalıştığı sürece yaptığı bütün sistem
çağrılarını, gönderdiği parametreler ve geri dönüş değerleriyle
birlikte döker.

%description -l uk.UTF-8
Програма strace перехоплює та регіструє системні визови, зроблені та
отримані процесом, який виконується. Strace може вивести список усіх
системних визовів, їх аргументів та значень, які вони повернули.
Strace корисний для діагностики проблем та відладки.

%package graph
Summary:	strace graph
Summary(pl.UTF-8):	Graf strace
Group:		Development/Debuggers
# NOTE: doesn't require directly strace binary.

%description graph
strace-graph script processes strace -f output. It displays a graph of
invoked subprocesses, and is useful for finding out what complex
commands do.

The script can also handle the output with strace -t, -tt, or -ttt. It
will add elapsed time for each process in that case.

%description graph -l pl.UTF-8
Skrypt strace-graph przetwarza wynik strace -f i wyświetla graf
wywoływanych podprocesów. Jest przydatny do sprawdzania co robią
złożone polecenia.

Skrypt jest w stanie obsłużyć także wyjście ze strace -t, -tt i -ttt.
Doda wtedy upływający czas dla każdego procesu.

%prep
%setup -q

%build
%if %{with libunwind}
# workaround for:
# /usr/bin/ld: copy reloc against protected `_UPT_accessors' is invalid
# /usr/bin/ld: failed to set dynamic section sizes: Bad value
# (should be fixed in gcc >(=?) 5.1)
CFLAGS="%{rpmcflags} -fPIE"
%endif
%configure \
	%{!?with_libunwind:--without-libunwind}
%{__make}

%install
rm -rf $RPM_BUILD_ROOT

%{__make} install \
	DESTDIR=$RPM_BUILD_ROOT

install -D %{SOURCE1} $RPM_BUILD_ROOT%{_mandir}/pl/man1/strace.1

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%doc COPYING CREDITS ChangeLog NEWS README-linux-ptrace
%attr(755,root,root) %{_bindir}/strace
%attr(755,root,root) %{_bindir}/strace-log-merge
%{_mandir}/man1/strace.1*
%lang(pl) %{_mandir}/pl/man1/strace.1*

%files graph
%defattr(644,root,root,755)
%attr(755,root,root) %{_bindir}/strace-graph
%changelog
* Wed Nov 15 2017 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/strace.git;a=log;h=master

* Wed Nov 15 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 2487f8b
- up to 4.20

* Tue Oct 03 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 70d2a35
- up to 4.19

* Wed Aug 09 2017 Arkadiusz Miśkiewicz <arekm@maven.pl> 27909ca
- up to 4.18

* Wed Oct 05 2016 Tomasz Pala <gotar@pld-linux.org> 59d94e5
- upgraded to 4.14

* Mon Jun 13 2016 Jakub Bogusz <qboosh@pld-linux.org> 12d7f67
- updated to 4.12

* Sat Dec 26 2015 Jakub Bogusz <qboosh@pld-linux.org> f33d183
- updated to 4.11

* Sat Apr 25 2015 Jakub Bogusz <qboosh@pld-linux.org> b293a86
- handle libunwind dependency / experimental stack tracing support

* Thu Apr 09 2015 Arkadiusz Miśkiewicz <arekm@maven.pl> 8bd9144
- up to 4.10

* Tue Feb 24 2015 Jan Rękorajski <baggins@pld-linux.org> 26f36c2
- x32 rebuild
- release 2 (by relup.sh)

* Wed Sep 17 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 56c27b3
- up to 3.9

* Mon Jan 27 2014 Arkadiusz Miśkiewicz <arekm@maven.pl> 53cc01c
- up to 4.8

* Mon Dec 17 2012 Arkadiusz Miśkiewicz <arekm@maven.pl> 417f4f4
- up to 4.7

* Fri Apr 01 2011 Jakub Bogusz <qboosh@pld-linux.org> e05c672
- xz BRs

* Wed Mar 30 2011 Arkadiusz Miśkiewicz <arekm@maven.pl> c56589b
- up to 4.6

* Sat Jan 29 2011 sparky <sparky@pld-linux.org> 0b74a37
- dropped pre-cvs changelog

* Thu Apr 15 2010 lisu <lisu@pld-linux.org> f6bae06
- adjust for 4.5.20

* Thu Apr 15 2010 lisu <lisu@pld-linux.org> dba2718
- up to 4.5.20
- adapter

* Thu Oct 22 2009 lisu <lisu@pld-linux.org> e8e62ae
- osbolete

* Thu Oct 22 2009 lisu <lisu@pld-linux.org> 723b165
- version up to 4.5.19
- removed patches: fd.patch, utilc.patch, semop.patch (applied upstream)
- more verbose files

* Wed Oct 07 2009 Jakub Bogusz <qboosh@pld-linux.org> cb2038a
- updated semop patch, release 5

